function dE = get_grad(net, y, z, u , x, t);

global psi

alpha = net{1};
w = net{2};
beta = net{3};

N = size(alpha,2);
L = size(w,3);
K = size(y,2);

dE = cell(1,3);
dEdz = zeros(N,K,L);
dEdw = zeros(N,N,L);

dEdy = y-t;
dEdb = dEdy*squeeze(z(:,:,L))';

dEdz(:,:,L) = beta'*dEdy;

for l = L:-1:2
    dEdw(:,:,l) = squeeze(z(:,:,l-1)) * ...
        (squeeze(dEdz(:,:,l)).*psi(squeeze(u(:,:,l))))';
    dEdz(:,:,l-1) = squeeze(w(:,:,l)) * ...
        (squeeze(dEdz(:,:,l)).*psi(squeeze(u(:,:,l))));
end

dEda = x * (squeeze(dEdz(:,:,1)).*psi(squeeze(u(:,:,1))))';

dE{1} = dEda;       % size (d,N)
dE{2} = dEdw;       % size (N,N,L)
dE{3} = dEdb;       % size (1,N)
